/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomDatabase_H__
#define __GdomDatabase_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomDatabase GdomDatabase;
typedef struct _GdomDatabaseClass GdomDatabaseClass;


#define GDOM_TYPE_DATABASE            (gdom_database_get_type())
#define GDOM_DATABASE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_DATABASE, GdomDatabase))
#define GDOM_DATABASE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_DATABASE, GdomDatabase)Class)
#define GDOM_IS_DATABASE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_DATABASE))
#define GDOM_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_DATABASE))
#define GDOM_DATABASE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_DATABASE, GdomDatabaseClass))

typedef struct _GdomDatabasePrivate GdomDatabasePrivate;

struct _GdomDatabase {
    GdomDOMObject parent_instance;
    GdomDatabasePrivate *priv;
};

struct _GdomDatabaseClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_database_get_type (void);


/* XXX TODO: custom function gdom_database_change_version */


/* XXX TODO: custom function gdom_database_transaction */

G_END_DECLS

#endif /* __GdomDatabase_H__ */
